import pymongo
from werkzeug.security import generate_password_hash

# get mongodb client, then database, then collection
db = pymongo.MongoClient(
    "mongodb://localhost:27017/", connect=False)['sfphotonweb']

users = db['users']
mc_users = db['mc_users']

def createBasicUser(username, password, **kwargs):
        basic_services = ['profile', 'minecraft', 'dyndns']

        pwhash = generate_password_hash(password, salt_length=4)
        userobj = None
        if 'registeredby' in kwargs.keys():
                userobj = {"username": username, "pwhash": pwhash, "services": basic_services, 'registeredby': kwargs['registeredby']}
        else:
                userobj = {"username": username, "pwhash": pwhash, "services": basic_services}
        users.insert_one(userobj)


def sendMessage(username, message):
        x = users.find_one({'username': username})
        if 'messages' not in x.keys():
                users.update_one(filter={'username': username}, update={"$set": {'messages': [message]}})
        else:
                msgs = x['messages']
                msgs.append(message)
                users.update_one(filter={'username': username}, update={"$set": {'messages': msgs}})


def hasMessages(username):
        x = users.find_one({'username': username})
        if 'messages' not in x.keys():
                return False
        if x['messages'] == []:
                return False
        return True


def getMessages(username):
        x = users.find_one({'username': username})
        if 'messages' not in x.keys():
                return []
        else:
                msgs = x['messages']
                users.update_one(filter={'username': username}, update={"$set": {'messages': []}})
                return msgs
