#!/bin/env python3

import pymongo
import sys

# get mongodb client, then database, then collection
users = pymongo.MongoClient(
    "mongodb://localhost:27017/")['sfphotonweb']['users']

def collect_other_users(username):
    other_users = []
    global users
    userobjs = users.find(filter={'redirectname': username})
    if userobjs != None:
        for user in userobjs:
            other_users.append(user['username'])
    return other_users

print("Use this feature to merge users (alias -> main).")
print("Example use case: a user can login both locally and with SCHAcc and we want it to behave as a single user")

oldname = input("Username to be converted to an alias: ")
redirectname = input("Main username: ")

old = users.find_one(filter={'username': oldname})
if old is None:
    raise Exception("Old user does not exist")

new = users.find_one(filter={'username': redirectname})
if new is None:
    raise Exception("New user does not exist")

if 'redirectname' in new:
    raise Exception(redirectname + ' is already an alias of ' + new['redirectname'])

if 'redirectname' in old:
    raise Exception(oldname + ' is already an alias of ' + old['redirectname'])

conflicts = users.count_documents(filter={'redirectname': old})
if conflicts != 0:
    raise Exception(oldname + ' already has some aliases')


pwsource = input("Use password of user: ")
pwuser = users.find_one(filter={'username': redirectname})
if pwuser is None:
    raise Exception("New user does not exist")
pwhash = pwuser['pwhash']

further_users=collect_other_users(redirectname)
print("This will affect the following users:")
print('  ' + oldname)
print('  ' + redirectname)
for user in further_users:
    print('  ' + user)
confirm = input("Are you sure to merge users? (y/n) ")
if not confirm == 'y':
    sys.exit(0)


newvalues = { "$set": {"pwhash": pwhash}}
users.update_one({'username': redirectname}, newvalues)
for user in further_users:
    users.update_one({'username': user}, newvalues)

newvalues = { "$set": {"redirectname": redirectname, "pwhash": pwhash}}
users.update_one({'username': oldname}, newvalues)