#!/bin/env python3

from werkzeug.security import generate_password_hash
import pymongo
from getpass import getpass

username = input("Username: ")
print("Password: ", end='')
password = getpass()

pwhash = generate_password_hash(password, salt_length=4)

# get mongodb client, then database, then collection
users = pymongo.MongoClient(
    "mongodb://localhost:27017/")['sfphotonweb']['users']

users.drop()

userobj = {"username": username, "pwhash": pwhash, "services": []}

x = users.insert_one(userobj)

print('Password hash (salted): ' + pwhash)
