#!/bin/env python3

from werkzeug.security import generate_password_hash
import pymongo
from getpass import getpass

id = input("ID: ")
url = input("Url (like https://ns.example.com): ")
key = getpass(prompt="Authentication key: ")

dyndnsServers = pymongo.MongoClient(
    "mongodb://localhost:27017/")['sfphotonweb']['dyndns-servers']

if not dyndnsServers.find_one({'id': id}) is None:
	raise Exception("A server already exists with this ID.")

dyndnsServers.insert_one({
	'id': id,
	'url': url,
	'keyhash': generate_password_hash(key, salt_length=4)
})
