#!/bin/env python3

from werkzeug.security import generate_password_hash
import pymongo
from getpass import getpass
import sys

username = input("Username: ")
print("Password: ", end='')
password = getpass()
pwhash = generate_password_hash(password, salt_length=4)

confirm = input("Are you sure to set new password? (y/n) ")
if not confirm == 'y':
    sys.exit(0)

# get mongodb client, then database, then collection
users = pymongo.MongoClient(
    "mongodb://localhost:27017/")['sfphotonweb']['users']

x = users.find_one(filter={'username': username})
if x is None:
    raise Exception("User does not exist")

newvalues = { "$set": {"pwhash": pwhash}}

users.update_one({'username': username}, newvalues)

print('Password hash (salted): ' + pwhash)
