import pymongo
import db


def get_service_menus(username: str, public_service_menu: dict, authorized_service_menu: dict):
    ret = {}
    if username is None:
        for (text, service) in public_service_menu:
            ret[text] = service
        return ret
    x = db.users.find_one(filter={'username': username})
    if x is None:
        return ret
    for service_name in x['services']:
        for (text, service, permission_name) in authorized_service_menu:        
            if permission_name == service_name:
                ret[text] = service
    for (text, service, permission_name) in authorized_service_menu:
        if permission_name == None:
            # public menu, should include here as well
            ret[text] = service
    return ret


def authorize_user(username: str, service: str):
    """check if a user may access a service"""
    if username is None:
        return False
    x = db.users.find_one(filter={'username': username})
    if x is None:
        return False
    return service in x['services']
